<?php
namespace SchamsNet\AwsSdkPhp;

/**
 * This file is part of the TYPO3 CMS Extension "AWS SDK for PHP"
 * Extension author: Michael Schams - https://schams.net
 *
 * The AWS SDK for PHP is copyright Amazon.com, Inc. or its affiliates.
 *
 * For copyright and license information, please read the LICENSE.txt
 * file distributed with this source code. For copyright and license
 * information of all AWS SDK for PHP sources and its 3rd party
 * components, please read the license files in the "Contrib" folder
 * and its sub-folders.
 */

class AwsService
{
	/**
	 * Constants
	 *
	 * ------------------------------------------------------------------
	 * Note: available services can be determined by:
	 *
	 * AWS SDK version 2.x.x
	 * cat Contrib/aws-autoloader.php | egrep "^[[:space:]]*'Aws\\\\" | sed 's;^[[:space:]]*.Aws\\\([^\\]*\).*;\1;g' | tr '[:upper:]' '[:lower:]' | sort | uniq
	 *
	 * AWS SDK version 3.1.x
	 * cat Contrib/Aws/Sdk.php | grep "@method" | sed 's;^.*Aws\\\([a-zA-Z0-9]*\).*;\1;g' | tr '[:upper:]' '[:lower:]' | sort | uniq
	 *
	 * ------------------------------------------------------------------
	 * ...and the list below can be generated by:
	 *
	 * AWS SDK version 2.x.x
	 * for SERVICE in $(cat Contrib/aws-autoloader.php | egrep "^[[:space:]]*'Aws\\\\" | sed 's;^[[:space:]]*.Aws\\\([^\\]*\).*;\1;g' | tr '[:upper:]' '[:lower:]' | sort | uniq); do CONSTANT=$(echo ${SERVICE} | tr '[:lower:]' '[:upper:]') ; echo -e "\tconst AWS_SERVICE_${CONSTANT} =\t\t\t\t'${SERVICE}';" ; done > /tmp/aws_sdk_php.services.txt
	 *
	 * AWS SDK version 3.1.x
	 * for SERVICE in $(cat Contrib/Aws/Sdk.php | grep "@method" | sed 's;^.*Aws\\\([a-zA-Z0-9]*\).*;\1;g' | tr '[:upper:]' '[:lower:]' | sort | uniq); do CONSTANT=$(echo ${SERVICE} | tr '[:lower:]' '[:upper:]') ; echo -e "\tconst AWS_SERVICE_${CONSTANT} =\t\t\t\t'${SERVICE}';" ; done > /tmp/aws_sdk_php.services.txt
	 *
	 * ------------------------------------------------------------------
	 *
	 * @access public
	 * @var constant
	 */
	const AWS_SERVICE_ACM =								'acm';
	const AWS_SERVICE_APIGATEWAY =						'apigateway';
	const AWS_SERVICE_APPLICATIONAUTOSCALING =			'applicationautoscaling';
	const AWS_SERVICE_APPLICATIONDISCOVERYSERVICE =		'applicationdiscoveryservice';
	const AWS_SERVICE_AUTOSCALING =						'autoscaling';
	const AWS_SERVICE_CLOUDFORMATION =					'cloudformation';
	const AWS_SERVICE_CLOUDFRONT =						'cloudfront';
	const AWS_SERVICE_CLOUDHSM =						'cloudhsm';
	const AWS_SERVICE_CLOUDSEARCH =						'cloudsearch';
	const AWS_SERVICE_CLOUDSEARCHDOMAIN =				'cloudsearchdomain';
	const AWS_SERVICE_CLOUDTRAIL =						'cloudtrail';
	const AWS_SERVICE_CLOUDWATCH =						'cloudwatch';
	const AWS_SERVICE_CLOUDWATCHEVENTS =				'cloudwatchevents';
	const AWS_SERVICE_CLOUDWATCHLOGS =					'cloudwatchlogs';
	const AWS_SERVICE_CODECOMMIT =						'codecommit';
	const AWS_SERVICE_CODEDEPLOY =						'codedeploy';
	const AWS_SERVICE_CODEPIPELINE =					'codepipeline';
	const AWS_SERVICE_COGNITOIDENTITY =					'cognitoidentity';
	const AWS_SERVICE_COGNITOIDENTITYPROVIDER =			'cognitoidentityprovider';
	const AWS_SERVICE_COGNITOSYNC =						'cognitosync';
	const AWS_SERVICE_CONFIGSERVICE =					'configservice';
	const AWS_SERVICE_DATABASEMIGRATIONSERVICE =		'databasemigrationservice';
	const AWS_SERVICE_DATAPIPELINE =					'datapipeline';
	const AWS_SERVICE_DEVICEFARM =						'devicefarm';
	const AWS_SERVICE_DIRECTCONNECT =					'directconnect';
	const AWS_SERVICE_DIRECTORYSERVICE =				'directoryservice';
	const AWS_SERVICE_DYNAMODB =						'dynamodb';
	const AWS_SERVICE_DYNAMODBSTREAMS =					'dynamodbstreams';
	const AWS_SERVICE_EC2 =								'ec2';
	const AWS_SERVICE_ECR =								'ecr';
	const AWS_SERVICE_ECS =								'ecs';
	const AWS_SERVICE_EFS =								'efs';
	const AWS_SERVICE_ELASTICACHE =						'elasticache';
	const AWS_SERVICE_ELASTICBEANSTALK =				'elasticbeanstalk';
	const AWS_SERVICE_ELASTICLOADBALANCING =			'elasticloadbalancing';
	const AWS_SERVICE_ELASTICSEARCHSERVICE =			'elasticsearchservice';
	const AWS_SERVICE_ELASTICTRANSCODER =				'elastictranscoder';
	const AWS_SERVICE_EMR =								'emr';
	const AWS_SERVICE_FIREHOSE =						'firehose';
	const AWS_SERVICE_GAMELIFT =						'gamelift';
	const AWS_SERVICE_GLACIER =							'glacier';
	const AWS_SERVICE_IAM =								'iam';
	const AWS_SERVICE_IMPORTEXPORT =					'importexport';
	const AWS_SERVICE_INSPECTOR =						'inspector';
	const AWS_SERVICE_IOT =								'iot';
	const AWS_SERVICE_IOTDATAPLANE =					'iotdataplane';
	const AWS_SERVICE_KINESIS =							'kinesis';
	const AWS_SERVICE_KMS =								'kms';
	const AWS_SERVICE_LAMBDA =							'lambda';
	const AWS_SERVICE_MACHINELEARNING =					'machinelearning';
	const AWS_SERVICE_MARKETPLACECOMMERCEANALYTICS =	'marketplacecommerceanalytics';
	const AWS_SERVICE_MARKETPLACEMETERING =				'marketplacemetering';
	const AWS_SERVICE_MULTIREGIONCLIENT =				'multiregionclient';
	const AWS_SERVICE_OPSWORKS =						'opsworks';
	const AWS_SERVICE_RDS =								'rds';
	const AWS_SERVICE_REDSHIFT =						'redshift';
	const AWS_SERVICE_ROUTE53 =							'route53';
	const AWS_SERVICE_ROUTE53DOMAINS =					'route53domains';
	const AWS_SERVICE_S3 =								's3';
	const AWS_SERVICE_SES =								'ses';
	const AWS_SERVICE_SERVICECATALOG =					'servicecatalog';
	const AWS_SERVICE_SNS =								'sns';
	const AWS_SERVICE_SQS =								'sqs';
	const AWS_SERVICE_SSM =								'ssm';
	const AWS_SERVICE_STORAGEGATEWAY =					'storagegateway';
	const AWS_SERVICE_STS =								'sts';
	const AWS_SERVICE_SUPPORT =							'support';
	const AWS_SERVICE_SWF =								'swf';
	const AWS_SERVICE_WAF =								'waf';
	const AWS_SERVICE_WORKSPACES =						'workspaces';
}